package br.ufes.inf.oak.estoque

import java.util.List;
import scala.collection.JavaConversions._;
import br.ufes.inf.oak.venda._;

class MapaProdutos {
  var mapaprodutos : Map[Int, Produto] = Map[Int, Produto]();
  
  def addProduto (p : Produto) : Unit = {
    var cod : Int = p.getCodigo();
    
    this.mapaprodutos += (cod -> p);
  } 
	
  def getProduto (codigoproduto : Int) : Produto = {
    return this.mapaprodutos(codigoproduto);
  }
  
  def getProdutos () = this.mapaprodutos
  
  def atualizaEstoqueCompras (compras : MapaCompras) : Unit = {
    for(compra : java.util.Map.Entry[Int, Compras] <- compras.getMapaCompras().entrySet()) {
      for(compra2 : java.util.Map.Entry[Int, List[Compra]] <- asScalaSet(compra.getValue().getCompras().entrySet())) {
        for(c : Compra <- asScalaBuffer(compra2.getValue())) {
          var p : Produto = this.mapaprodutos(c.getCodigoProduto());
          p.addEstoque(c.getQuantidade());
          this.mapaprodutos += (ArrowAssoc(p.getCodigo()) -> p);
        }
      }
    }
  }
  
  def atualizaEstoqueVendas (vendas : MapaVendas) : Unit = {
    for(venda : java.util.Map.Entry[Int, java.util.List[Venda]] <- asScalaSet(vendas.getMapaVendas().entrySet())) {
      for(v : Venda <- asScalaBuffer(venda.getValue())) {
        var p : Produto = this.mapaprodutos(v.getCodigoProduto());
        p.addEstoque(-1 * v.getQuantidade());
        p.addQuantidadeVendida(v.getQuantidade());
        this.mapaprodutos += (ArrowAssoc(p.getCodigo()) -> p);
      }
    }
  }
}