package br.ufes.inf.oak.estoque

import java.text.NumberFormat;
import java.util.Locale;
import java.lang.Comparable;

class Produto (_cod : Int, _desc : String, _estm : Int, _esta : Int, _custo : Double, _perl : Int) extends Comparable[Produto] {
	/* constructed vars */
	private[this] var codigo : Int = _cod;
	private[this] var descricao : String = _desc;
	private[this] var estoqueminimo : Int = _estm;
	private[this] var estoqueatual : Int = _esta;
	private[this] var custo : Double = _custo;
	private[this] var percentlucro : Int = _perl;
	
	private[this] var lucro : Double = 0;
	private[this] var bruto : Double = 0;
	
	def addQuantidadeVendida (qtd : Int) : Unit = {
	  this.bruto += this.valorVenda() * qtd;
	  this.lucro += Math.round(this.custo * (this.percentlucro))/100d * qtd;
	}
	
	def mostraProduto () : String = {
	  val nf : java.text.NumberFormat = NumberFormat.getCurrencyInstance(new java.util.Locale("pt", "br"));
	  
	  return this.codigo + ";" + this.descricao + ";" + nf.format(this.bruto) + ";" + nf.format(this.lucro);
	}
	
	def mostraProduto2 () : String = {
	  return this.codigo + ";" + this.descricao + ";" + this.bruto + ";" + this.lucro;
	}
	
	def getCusto () : Double = {
	  return Math.round(this.custo * 100)/100d;
	}
	
	def addEstoque (qtd : Int) : Unit = {
	  this.estoqueatual += qtd;
	}
	
	def valorVenda () : Double = {
	  return this.custo + Math.round(this.custo * (this.percentlucro))/100d;
	}
	
	def getCodigo () : Int = {
	  return this.codigo;
	}
	
	/* probably won't be used */
	def getLucro () : Double = {
	  return this.lucro;
	}
	
	override def compareTo (p : Produto) : Int = {
		val result : Int = p.getLucro().toInt - this.lucro.toInt;
		
		if(result != 0) return result;
		
		return this.codigo - p.getCodigo();
	}
}