package br.ufes.inf.oak.principal

import br.ufes.inf.oak.clientes._;
import br.ufes.inf.oak.estoque.Compra;
import br.ufes.inf.oak.estoque.Produto;
import br.ufes.inf.oak.fornecedor.Fornecedor;
import br.ufes.inf.oak.venda.Venda;

class Cadastros {
	def novoCliente (leitor : java.util.Scanner) : Cliente = {
		val linha : String = leitor.nextLine();
		
		if(linha.isEmpty()) {
			return null;
		}
		
		val df : java.text.DateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
		val linha2 : Array[String] = linha.split(";");
		val codigo : Int = java.lang.Integer.parseInt(linha2(0));
		val nome : String = linha2(1);
		val endereco : String = linha2(2);
		val telefone : String = linha2(3);
		val datacadastro : java.util.Date = df.parse(linha2(4));
		var tipo : Char = linha2(5).charAt(0);
		val cpfcnpj : String = linha2(6);
		
		if(tipo == 'f') {
			tipo = 'F';
			
			return new ClienteFisico(codigo, nome, endereco, datacadastro, telefone, tipo, cpfcnpj);
		} else if(tipo == 'j') {
			tipo = 'J';
			
			val inscricao : Int = java.lang.Integer.parseInt(linha2(7));
			
			return new ClienteJuridico(codigo, nome, endereco, datacadastro, telefone, tipo, cpfcnpj, inscricao);
		}
		return null;
	}
	
	def novoFornecedor (leitor : java.util.Scanner) : Fornecedor = {
		val linha : String = leitor.nextLine();
	  	
	  	if(linha.isEmpty()) {
	  		return null;
	  	}
	  	
	  	val linha2 : Array[String] = linha.split(";");
	  	val codigo : Int = java.lang.Integer.parseInt(linha2(0));
	  	val nome : String = linha2(1);
	  	val endereco : String = linha2(2);
	  	val telefone : String = linha2(3);
	  	val cnpj : String = linha2(4);
	  	val pessoacontato : String = linha2(5);
	  	
	  	return new Fornecedor(codigo, nome, endereco, telefone, cnpj, pessoacontato);
	}
	
	def novoProduto (leitor : java.util.Scanner) : Produto = {
		val linha : String = leitor.nextLine();
		
		if(linha.isEmpty()) {
			return null;
		}
		
		val linha2 : Array[String] = linha.split(";");
		val codigo : Int = java.lang.Integer.parseInt(linha2(0));
		val descricao : String = linha2(1);
		val estoqueminimo : Int = java.lang.Integer.parseInt(linha2(2));
		val estoqueatual : Int = java.lang.Integer.parseInt(linha2(3));
		val custo : Double = java.lang.Double.parseDouble(linha2(4).replaceAll(",", "."));
		val percentlucro : Int = java.lang.Integer.parseInt(linha2(5));
		
		return new Produto(codigo, descricao, estoqueminimo, estoqueatual, custo, percentlucro);
	}
	
	def novaCompra (leitor : java.util.Scanner) : Compra = { 
		val linha : String = leitor.nextLine();
		
		if(linha.isEmpty()) {
			return null;
		}
		
		val df : java.text.DateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
		val linha2 : Array[String] = linha.split(";");
		val notafiscal : Int = java.lang.Integer.parseInt(linha2(0));
		val fornecedor : Int = java.lang.Integer.parseInt(linha2(1));
		val datacompra : java.util.Date = df.parse(linha2(2));
		val codigoproduto : Int = java.lang.Integer.parseInt(linha2(3));
		val quantidade : Int = java.lang.Integer.parseInt(linha2(4));
		
		return new Compra(notafiscal, fornecedor, datacompra, codigoproduto, quantidade);
	}
	
	def novaVenda (leitor : java.util.Scanner) : Venda = {
		val linha : String = leitor.nextLine();
		
		if(linha.isEmpty()) {
			return null;
		}
		
		val df : java.text.DateFormat = new java.text.SimpleDateFormat("dd/MM/yyyy");
		val linha2 : Array[String] = linha.split(";");
		var codigocliente : Int = 0;
		
		if(linha2(0).isEmpty()) {
			codigocliente = -1;
		} else {
			codigocliente = java.lang.Integer.parseInt(linha2(0));
		}
		
		val datavenda : java.util.Date = df.parse(linha2(1));
		val codigoproduto : Int = java.lang.Integer.parseInt(linha2(2));
		val quantidade : Int = java.lang.Integer.parseInt(linha2(3));
		val modopgto : Char = linha2(4).charAt(0);
		
		return new Venda(codigocliente, datavenda, codigoproduto, quantidade, modopgto);
	}
}