package br.ufes.inf.oak.principal

import br.ufes.inf.oak.clientes._;
import br.ufes.inf.oak.estoque._;
import br.ufes.inf.oak.fornecedor._;
import br.ufes.inf.oak.venda._;

class Main {
	
	def main (args : Array[String]) {
		var clientesarq : java.io.File = null;
		var fornecedoresarq : java.io.File = null;
		var produtosarq : java.io.File = null;
		var comprasarq : java.io.File = null;
		var vendasarq : java.io.File = null;
		
		val padaria : Main = new Main();
		var i = 0;
		
		while(i < args.length) {
			if(args(i).equals("-c")) {
				i = i + 1;
				clientesarq = new java.io.File(args(i));
			}
			else if(args(i).equals("-f")) {
				i = i + 1;
				fornecedoresarq = new java.io.File(args(i));
			}
			else if(args(i).equals("-p")) {
				i = i + 1;
				produtosarq = new java.io.File(args(i));
			}
			else if(args(i).equals("-a")) {
				i = i + 1;
				comprasarq = new java.io.File(args(i));
			}
			else if(args(i).equals("-v")) {
				i = i + 1;
				vendasarq = new java.io.File(args(i));
			}
			
			i = i + 1;
		}
		
		padaria.execucaoNormal(clientesarq, fornecedoresarq, produtosarq, comprasarq, vendasarq);
	}
	
	def execucaoNormal (ca : java.io.File, fa : java.io.File, pa : java.io.File, cpa : java.io.File, va : java.io.File) : Unit = {
		var leitor : java.util.Scanner = null;
		val padaria : Cadastros = new Cadastros();
		val clientes : MapaClientes = new MapaClientes();
		val fornecedores : MapaFornecedores = new MapaFornecedores();
		val produtos : MapaProdutos = new MapaProdutos();
		val compras : MapaCompras = new MapaCompras();
		val vendas : MapaVendas = new MapaVendas();
		
		leitor = new java.util.Scanner(ca, "UTF-8");
		leitor.nextLine();
		
		while(leitor.hasNextLine()) {
			val c : Cliente = padaria.novoCliente(leitor);
			if(c != null) {
				clientes.addCliente(c);
			}
		}
		
		leitor = new java.util.Scanner(fa, "UTF-8");
		leitor.nextLine();
		
		while(leitor.hasNextLine()) {
			val f : Fornecedor = padaria.novoFornecedor(leitor);
			if(f != null) {
				fornecedores.addFornecedor(f);
			}
		}
		
		leitor = new java.util.Scanner(pa, "UTF-8");
		leitor.nextLine();
		
		while(leitor.hasNextLine()) {
			val p : Produto = padaria.novoProduto(leitor);
			if(p != null) {
				produtos.addProduto(p);
			}
		}
		
		leitor = new java.util.Scanner(cpa, "UTF-8");
		leitor.nextLine();
		
		while(leitor.hasNextLine()) {
			val c : Compra = padaria.novaCompra(leitor);
			if(c != null) {
				compras.addCompra(c);
			}
		}
		
		leitor = new java.util.Scanner(va, "UTF-8");
		leitor.nextLine();
		
		while(leitor.hasNextLine()) {
			val v : Venda = padaria.novaVenda(leitor);
			if(v != null) {
				vendas.addVenda(v);
			}
		}
		
		produtos.atualizaEstoqueCompras(compras);
		produtos.atualizaEstoqueVendas(vendas);
		
		val relatorio = new Relatorios();
		
		relatorio.relatorioVendasProd(produtos);
		relatorio.relatorioTotalaPagar(fornecedores, compras, produtos);
		
		leitor.close();
	}
}

object teste {
	def main (args : Array[String]) {
		var main : Main = new Main();
		main.main(args);
	}
}