package br.ufes.inf.oak.principal

import br.ufes.inf.oak.estoque._;
import br.ufes.inf.oak.fornecedor._;
import scala.collection.JavaConversions._;
import java.io.IOException;

class Relatorios {
	def relatorioVendasProd (produtos : MapaProdutos) : Unit = {
		val pds : java.util.List[Produto] = new java.util.LinkedList[Produto]();
		
		for(p : java.util.Map.Entry[Int, Produto] <- asScalaSet(mapAsJavaMap(produtos.getProdutos()).entrySet())) {
			pds.add(p.getValue());
		}
		
		java.util.Collections.sort(pds);
		
		var relatorio : java.io.BufferedWriter = null;
		
		try {
			relatorio = new java.io.BufferedWriter(new java.io.FileWriter("3-vendasprod.csv"));
			relatorio.write("Cdigo;Produto;Receita bruta; Lucro\n");
			
			for(p : Produto <- asScalaBuffer(pds)) {
				relatorio.write(p.mostraProduto() + "\n");
			}
		} catch {
		  	case e : java.io.IOException => {
		  		println("Erro no relatorio 3-vendasprod.csv");
		  	}
		} finally {
			try {
				relatorio.close();
			} catch {
			  	case e : java.lang.Exception => {
			  		println(RichException(e).getStackTraceString);
			  	}
			}
		}
	}
	
	def relatorioTotalaPagar (fornecedores : MapaFornecedores, compras : MapaCompras, produtos : MapaProdutos) : Unit = {
		var relatorio : java.io.BufferedWriter = null;
		
		try { 
			relatorio = new java.io.BufferedWriter(new java.io.FileWriter("1-apagar.csv"));
			relatorio.write("Fornecedor;CNPJ;Pessoa de contato;Telefone;Total a pagar\n");
			
			val nf = java.text.NumberFormat.getCurrencyInstance(new java.util.Locale("pt", "br"));
			
			val lf : java.util.List[Fornecedor] = new java.util.LinkedList[Fornecedor]();
			
			for(fornecedor : java.util.Map.Entry[Int, Fornecedor] <- asScalaSet(fornecedores.getFornecedores().entrySet())) {
				lf.add(fornecedor.getValue());
			}
			
			java.util.Collections.sort(lf);
			
			for(f <- asScalaBuffer(lf)) {
				var valorapagar = 0d;
				for(compra : java.util.Map.Entry[Int, Compras] <- asScalaSet(compras.getMapaCompras().entrySet())) {
					for(compra2 : java.util.Map.Entry[Int, java.util.List[Compra]] <- asScalaSet(compra.getValue().getCompras().entrySet())) {
						for(c : Compra <- asScalaBuffer(compra2.getValue())) {
							if(c.getCodigoFornecedor() == f.getCodigo()) {
								var p : Produto = produtos.getProduto(c.getCodigoProduto());
								valorapagar += p.getCusto() * c.getQuantidade();
							}
						}
					}
				}
				
				relatorio.write(f.toString() + ";" + nf.format(valorapagar) + "\n");
			}
			
		} catch {
		  	case e : IOException => {
		  		println("Erro no relatorio 1-apagar.csv");
		  	}
		} finally {
			try {
				relatorio.close();
			} catch {
			  	case e : java.lang.Exception => {
			  		println(RichException(e).getStackTraceString);
			  	}
			}
		}
		
	}
}